//+------------------------------------------------------------------+
//|                                              MODIFY BY LEONID553 |
//+------------------------------------------------------------------+
#property copyright "leonid553@ya.ru"
#property link      "http://articles.mql4.com/ru/403"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Lime
#property indicator_color2 MediumAquamarine
#property indicator_color3 DodgerBlue
#property indicator_color4 Blue
#property indicator_level1 0
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2

extern string  Symbol_1 = "USDCHF";
extern string  Symbol_2 = "USDJPY";
extern int N1 = 1000;
extern int N2 = 10;
extern bool   TRIANGLE =True ; 
 extern color  Triangle.Color = DarkSalmon; //    
extern string  _________  = "===   ==="; 
extern int MA_per =  21;
extern int MA_fast = 8;
extern int ma_method=2;
extern int Price=6;
//---- buffers
double Symbol1[]; double Symbol2[];
double Symbol1UP[]; double Symbol2UP[];
double Symbol1DN[]; double Symbol2DN[];
int wndNum;                                //   
string wndName;                            //  
string  oTriangle;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(6);

SetIndexStyle(0,DRAW_LINE);SetIndexBuffer(0,Symbol1UP);SetIndexLabel(0,Symbol_1); 
SetIndexStyle(1,DRAW_LINE);SetIndexBuffer(1,Symbol1DN);SetIndexLabel(1,Symbol_1); 
SetIndexStyle(2,DRAW_LINE);SetIndexBuffer(2,Symbol2UP);SetIndexLabel(2,Symbol_2); 
SetIndexStyle(3,DRAW_LINE);SetIndexBuffer(3,Symbol2DN);SetIndexLabel(3,Symbol_2); 

SetIndexBuffer(4,Symbol1);
SetIndexBuffer(5,Symbol2);
      return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()  {
  //    
  ObjectDelete("Symbol1");
  ObjectDelete("Symbol2"); 
  ObjectDelete("TRIANGLE");
  return(0);  
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {  //int limit;
   int counted_bars=IndicatorCounted();
   int limit=Bars - IndicatorCounted();  
   if (limit>1) {
      limit=Bars-MathMax(MA_per,MA_fast)-1;
   }
 //    
  wndNum=WindowFind(WindowExpertName());
  wndName=WindowExpertName()+wndNum; 
  
  //----  
      int per1,per2;
      per1 = MA_per;   per2 = MA_fast; 
  //------------------------------------------------------------

   for(int k = limit; k >=0; k--)   {  
      Symbol1[k]=
            (iMA(Symbol_1,Period(),per2,0,ma_method,Price,iBarShift(Symbol_1,0,Time[k],false))-
            iMA(Symbol_1,Period(),per1,0,ma_method,Price,iBarShift(Symbol_1,0,Time[k],false)))*N1  ;            
            
      Symbol1UP[k]=EMPTY_VALUE;
      Symbol1DN[k]=EMPTY_VALUE;
      Symbol2UP[k]=EMPTY_VALUE;
      Symbol2DN[k]=EMPTY_VALUE;

      if (Symbol1[k]>Symbol1[k+1]) {
         Symbol1UP[k]=Symbol1[k];
         Symbol1UP[k+1]=Symbol1[k+1];
      } else {
         Symbol1DN[k]=Symbol1[k];
         Symbol1DN[k+1]=Symbol1[k+1];
      }         
      Symbol2[k]=
            (iMA(Symbol_2,Period(),per2,0,ma_method,Price,iBarShift(Symbol_2,0,Time[k],false))-
            iMA(Symbol_2,Period(),per1,0,ma_method,Price,iBarShift(Symbol_2,0,Time[k],false)))*N2   ;           
      if (Symbol2[k]>Symbol2[k+1]) {
         Symbol2UP[k]=Symbol2[k];
         Symbol2UP[k+1]=Symbol2[k+1];
      } else {
         Symbol2DN[k]=Symbol2[k];
         Symbol2DN[k+1]=Symbol2[k+1];
      }         
   } 
//----------------   -----------------------------
if (TRIANGLE==true )   {//    
 datetime  level_1, level_2, level_3;
 double    delta_1,delta_2, delta_3 ; 
    double PriceMax   =  WindowPriceMax(wndNum);
    double PriceMin   =  WindowPriceMin(wndNum);
    double PriceMid   = (PriceMax+PriceMin)/2;
    double PriceDelta = (PriceMax-PriceMin)/4;
    datetime BegTime, EndTime;
    BegTime=Time[0]+Period()*233;
    EndTime=Time[0]+Period()*700;
          
if ( MathAbs(Symbol1[1]-Symbol2[1]) > MathAbs(Symbol1[0]-Symbol2[0]) )
 {//      ,   -  
      level_1=BegTime;  delta_1 = PriceMid+PriceDelta;
      level_2=BegTime;  delta_2 = PriceMid-PriceDelta;
      level_3=EndTime;  delta_3 = PriceMid;          
 }       
if ( MathAbs(Symbol1[1]-Symbol2[1]) <= MathAbs(Symbol1[0]-Symbol2[0]) )
{//      ,   -      
      level_1=BegTime; delta_1 = PriceMid;
      level_2=EndTime; delta_2 = PriceMid+PriceDelta;
      level_3=EndTime; delta_3 = PriceMid-PriceDelta;       
  } 
  //==   ===================                  
ObjectCreate("TRIANGLE", OBJ_TRIANGLE,WindowFind(WindowExpertName()), 
                  level_1, delta_1 ,level_2,delta_2,level_3,delta_3); 
  ObjectSet("TRIANGLE", OBJPROP_COLOR,Triangle.Color); 
  ObjectSet("TRIANGLE", OBJPROP_PRICE1, delta_1);
  ObjectSet("TRIANGLE", OBJPROP_PRICE2, delta_2);
  ObjectSet("TRIANGLE", OBJPROP_PRICE3, delta_3);
  ObjectSet("TRIANGLE", OBJPROP_TIME1, level_1);
  ObjectSet("TRIANGLE", OBJPROP_TIME2, level_2);
  ObjectSet("TRIANGLE", OBJPROP_TIME3, level_3); 
    } //     

//        : 
 object("Symbol1", N1+"*"+Symbol_1, 10, indicator_color1, 5);
 object("Symbol2", N2+"*"+Symbol_2, 10, indicator_color3, 18);

//-----------------------------------------------------   
    return(0);
  }
//+------------------------------------------------------------------+

void object(string name, string _text, int fontsize, color color_, int value) {
 ObjectCreate(name+ WindowExpertName(), OBJ_LABEL, WindowFind(WindowExpertName()), 0, 0);
 ObjectSetText(name+ WindowExpertName(), _text, fontsize, "Times New Roman", color_);
 ObjectSet(name+ WindowExpertName(), OBJPROP_CORNER, 1);
 ObjectSet(name+ WindowExpertName(), OBJPROP_XDISTANCE, 4);
 ObjectSet(name+ WindowExpertName(), OBJPROP_YDISTANCE, value); 
                                 }